from typing import List
from unittest.mock import MagicMock, patch

import pytest

from workspaces.capability.schema import CapabilityRequest
from workspaces.capability.services.capability_info import CapabilityInfo
from workspaces.capability.services.capability_service import CapabilityService
from workspaces.capability.services.execution_manager import ExecutionManager
from workspaces.workflow.services.workflow_service import WorkflowService

pytest_plugins = ["testing.utils.conftest"]


@pytest.fixture(scope="module")
def dummy_execution_manager(
    mock_capability_info: CapabilityInfo, mock_workflow_service: WorkflowService
) -> ExecutionManager:
    """
    Pytest fixture that instantiates a dummy ExecutionManager object for testing purposes

    :return: Dummy ExecutionManager
    """
    return ExecutionManager(mock_capability_info, mock_workflow_service)


def test_run_capability(
    dummy_execution_manager: ExecutionManager,
    mock_capability_info: CapabilityInfo,
    mock_capability_request: List[CapabilityRequest],
):
    """
    Tests that run_capability correctly creates an execution given a request and enqueues that execution
    if the first capability step is running a workflow
    """
    # Mock enqueue_execution so the execution is not enqueued
    # dummy_execution_manager.enqueue_execution = MagicMock()

    # null_capability_request = mock_capability_request[0]
    # null_execution = dummy_execution_manager.run_capability(null_capability_request)
    # assert dummy_execution_manager.enqueue_execution.call_count == 1
    # assert null_execution.state == "Ready"
    # test_capability_request = mock_capability_request[1]
    # test_execution = dummy_execution_manager.run_capability(test_capability_request)
    # assert dummy_execution_manager.enqueue_execution.call_count == 1
    # assert len(dummy_execution_manager.execution_pool) == 1
    # assert test_execution.state == "Ready"
    assert True
