from enum import Enum


class WorkflowRequestState(Enum):
    """
    Enum that specifies the states a WorkflowRequest can find itself in
    """

    Complete = 0
    Created = 1
    Running = 2
    Failed = -1


class WorkflowEventType(Enum):
    """
    Kinds of events that a workflow can send. These four are derived from
    the many kinds that HTCondor can send.
    """

    SUBMITTED = 0
    EXECUTING = 1
    TERMINATED = 5
    OTHER = -1
